package org.openxma.dsl.reference.dao.impl;

import org.openxma.dsl.platform.dao.*;
import org.openxma.dsl.platform.dao.impl.*;
import org.openxma.dsl.platform.service.Mapper;

import org.hibernate.Criteria;
import org.hibernate.Query;
import org.hibernate.SessionFactory;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.Expression;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Qualifier;
import org.springframework.jdbc.support.incrementer.DataFieldMaxValueIncrementer;
import org.springframework.stereotype.Repository;
import org.springframework.util.Assert;
import org.openxma.dsl.reference.dao.RoleDao;
import org.openxma.dsl.reference.model.Role;
import org.openxma.dsl.reference.model.impl.RoleImpl;
/**
 * @see RoleDao
 */
@SuppressWarnings("unused")
public abstract class RoleDaoGenImpl extends GenericDaoHibernateImpl<Role,String> implements RoleDao {

    public RoleDaoGenImpl() {
        super(RoleImpl.class);
    }
    
    /**
     * @param context the context for the object creation
     * @return a transient instance of entity <code>Role</code> with an already assigned identifier.
     */
    public Role createEntity(Object context) {
        return create();
    }

    public Role create()
    {
        Role role = createEntityInstance();
        role.setOid(dataFieldMaxValueIncrementer.nextStringValue());
        return role;
    }
    
    protected Mapper getNamedQueryMapper(String queryName) {
		return new RoleDaoQueryMapper();
	}
	
	protected class RoleDaoQueryMapper extends NamedQueryMapper {
	
		@SuppressWarnings("unchecked")
		public <E> E mapOne(Object sourceObject, E targetObject, Object context) {
			return super.mapOne(sourceObject, targetObject);
		}
	}
}
