package org.openxma.dsl.reference.types.valueobject;

/**
 * Represents a custom DataType for <code>VOI18Enumeration</code>.
 */
public class VOI18Enumeration extends org.openxma.dsl.platform.valueobject.ValueObjectString {

    /**
     * Put the control and responsibility on the developer to determine the version of the
     * serialization class with which a serialized object is compatible.
     */
    private static final long serialVersionUID = 100L;

    /**
     * default ctor
     */
    public VOI18Enumeration(String pString) {
    	super(pString);
    }

    /**
     * Create a new instance of VOI18Enumeration or return null depending on input.
     */
    public static VOI18Enumeration newOrNull(String pString) {
        if (pString != null) {
            return new VOI18Enumeration(pString);
        }
        return null;
    }

}
