package org.openxma.dsl.reference.types.valueobject;

/**
 * Represents a custom DataType for <code>VOXml</code>.
 */
public class VOXml extends org.openxma.dsl.platform.valueobject.ValueObjectXml {

    /**
     * Put the control and responsibility on the developer to determine the version of the
     * serialization class with which a serialized object is compatible.
     */
    private static final long serialVersionUID = 100L;

    /**
     * default ctor
     */
    public VOXml(org.openxma.dsl.platform.valueobject.XmlPersistenceObject pXmlPersistenceObject) {
    	super(pXmlPersistenceObject);
    }

    /**
     * Create a new instance of VOXml or return null depending on input.
     */
    public static VOXml newOrNull(org.openxma.dsl.platform.valueobject.XmlPersistenceObject pXmlPersistenceObject) {
        if (pXmlPersistenceObject != null) {
            return new VOXml(pXmlPersistenceObject);
        }
        return null;
    }

}
