package org.openxma.dsl.reference.ui.layouting.server;

import at.spardat.xma.page.*;
import at.spardat.xma.component.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;

/**
 * This class implements the generic server part of RelativeAttachment.
 * It implements the models of the page.
 *
 */
public abstract class RelativeAttachmentGen extends PageServer {
    ISimpleWM t1a;
    ISimpleWM t1b;
    ISimpleWM t1c;
    ISimpleWM t1d;
    ISimpleWM customer1_firstName;
    ISimpleWM t2b;
    ISimpleWM t2c;
    ISimpleWM t3a;
    ISimpleWM t3b;
    ISimpleWM t3c;
    ISimpleWM t4a;
    ISimpleWM t4b;
    ISimpleWM t5a;
    ISimpleWM t5b;
    WModel[] widgetModels;


    /**
     * Constructs the RelativeAttachmentGen.
     * This constructor is called by the runtime. Do not remove!
     *
     * @param component the component this page belongs to
     */
    public RelativeAttachmentGen(ComponentServer component) {
        super(component, false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     */
    public void createModels() {
        t1a = new SimpleWM((short) 0, Types.T_STRING, this);
        t1b = new SimpleWM((short) 1, Types.T_STRING, this);
        t1c = new SimpleWM((short) 2, Types.T_STRING, this);
        t1d = new SimpleWM((short) 3, Types.T_STRING, this);
        customer1_firstName = new SimpleWM((short) 4, Types.T_STRING, this);
        t2b = new SimpleWM((short) 5, Types.T_STRING, this);
        t2c = new SimpleWM((short) 6, Types.T_STRING, this);
        t3a = new SimpleWM((short) 7, Types.T_STRING, this);
        t3b = new SimpleWM((short) 8, Types.T_STRING, this);
        t3c = new SimpleWM((short) 9, Types.T_STRING, this);
        t4a = new SimpleWM((short) 10, Types.T_STRING, this);
        t4b = new SimpleWM((short) 11, Types.T_STRING, this);
        t5a = new SimpleWM((short) 12, Types.T_STRING, this);
        t5b = new SimpleWM((short) 13, Types.T_STRING, this);

        widgetModels = new WModel[] { (WModel) t1a, (WModel) t1b, (WModel) t1c, (WModel) t1d, (WModel) customer1_firstName, (WModel) t2b, (WModel) t2c, (WModel) t3a, (WModel) t3b, (WModel) t3c, (WModel) t4a, (WModel) t4b, (WModel) t5a, (WModel) t5b };
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Layouting.RelativeAttachmentClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Layouting getTypedComponent() {
        return (Layouting) getComponent();
    }

    /**
     * Copies values of all attached widget models to attributes of the BusinessData instance variables.
     * Copies them for this page and all contained NotebookPages and statically embedded Pages
     * (embedded via XMAContainer in guidesigner)
     */
    public void modelToInstanceData() {
        atomicWMToBusinessData(getTypedComponent().getCustomer1());
    }

    /**
     * Copies attribute values of the BusinessData instance variables into their attached widget models.
     * This includes simple widget models and tables.
     * Copies them for this page and all contained NotebookPages and statically embedded Pages
     * (embedded via XMAContainer in guidesigner)
     */
    public void instanceDataToModel() {
        businessDataToAtomicWM(getTypedComponent().getCustomer1());
    }

    /**
     * Copies values of widget models to attributes of the provided BusinessData objects.
     */
    public void atomicWMToBusinessData(org.openxma.dsl.reference.dto.CustomerView customer1) {
        customer1.setFirstName(customer1_firstName.toString());
    }

    /**
     * Copies attribute values of the provided BusinessDatas into widget models.
     */
    public void businessDataToAtomicWM(org.openxma.dsl.reference.dto.CustomerView customer1) {
        customer1_firstName.set(customer1.getFirstName());
    }

    /**
     * Sets the given subpage. The method automatically chooses the
     * correct member variable to set.
     * @param child the subpage to set.
     */
    public void setChild(PageServer child) {
       // no subpages - nothing to do
    }

    /**
     * Removes the given subpage. The method automatically chooses the
     * correct member variable to clear.
     * @param child the subpage to set.
     */
    public void removeChild(PageServer child) {
       // no subpages - nothing to do
    }

}
