package org.openxma.dsl.reference.ui.layouting.server;

import at.spardat.xma.page.*;
import at.spardat.xma.component.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;

/**
 * This class implements the generic server part of SiblingAttachment.
 * It implements the models of the page.
 *
 */
public abstract class SiblingAttachmentGen extends PageServer {
    ISimpleWM t1a;
    ISimpleWM t1b;
    ISimpleWM t1c;
    ISimpleWM t1e;
    ISimpleWM t1f;
    ISimpleWM t1g;
    ISimpleWM t1h;
    WModel[] widgetModels;


    /**
     * Constructs the SiblingAttachmentGen.
     * This constructor is called by the runtime. Do not remove!
     *
     * @param component the component this page belongs to
     */
    public SiblingAttachmentGen(ComponentServer component) {
        super(component, false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     */
    public void createModels() {
        t1a = new SimpleWM((short) 0, Types.T_STRING, this);
        t1b = new SimpleWM((short) 1, Types.T_STRING, this);
        t1c = new SimpleWM((short) 2, Types.T_STRING, this);
        t1e = new SimpleWM((short) 3, Types.T_STRING, this);
        t1f = new SimpleWM((short) 4, Types.T_STRING, this);
        t1g = new SimpleWM((short) 5, Types.T_STRING, this);
        t1h = new SimpleWM((short) 6, Types.T_STRING, this);

        widgetModels = new WModel[] { (WModel) t1a, (WModel) t1b, (WModel) t1c, (WModel) t1e, (WModel) t1f, (WModel) t1g, (WModel) t1h };
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Layouting.SiblingAttachmentClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Layouting getTypedComponent() {
        return (Layouting) getComponent();
    }

    /**
     * Sets the given subpage. The method automatically chooses the
     * correct member variable to set.
     * @param child the subpage to set.
     */
    public void setChild(PageServer child) {
       // no subpages - nothing to do
    }

    /**
     * Removes the given subpage. The method automatically chooses the
     * correct member variable to clear.
     * @param child the subpage to set.
     */
    public void removeChild(PageServer child) {
       // no subpages - nothing to do
    }

}
