package org.openxma.dsl.reference.validation;

import org.springframework.validation.Errors;
import org.openxma.dsl.platform.validation.Validators;
import org.openxma.dsl.reference.model.Bug;
import org.springframework.validation.ValidationUtils;

@SuppressWarnings("boxing")
public abstract class BugGenValidator extends Validators {
    
    public boolean isBugIdRequired(Bug bug) {
        return Boolean.TRUE;
    }
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return Bug.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(Bug bug) {
        Errors errors = createErrors(bug);      
        validate(bug,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        Bug bug = (Bug) object;
        if (isBugIdRequired(bug)) {
            ValidationUtils.rejectIfEmptyOrWhitespace(errors, "bugId", "field.required");
        }
    }
    
}
