package org.openxma.dsl.reference.xma.customeredit.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.widgets.DatePicker;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;
import at.spardat.enterprise.util.*;
import at.spardat.xma.mdl.simple.*;
import at.spardat.enterprise.fmt.*;

/**
 * This class implements the generic client part of Page1.
 * It implements the widgets and models of the page.
 *
 */
public abstract class Page1Gen extends org.openxma.dsl.platform.xma.client.DslNotebookPage {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    private Scaler scaler = null;
    Composite infoCompositeW;
    Composite infoComposite_set0W;
    Label infoComposite_set0_centered;
    Label customer_firstNameL;
    Text customer_firstNameW;
    ISimpleWMClient customer_firstName;
    Composite infoComposite_set1W;
    Label infoComposite_set1_centered;
    Label customer_lastNameL;
    Text customer_lastNameW;
    ISimpleWMClient customer_lastName;
    Composite infoComposite_set2W;
    Label infoComposite_set2_centered;
    Label customer_emailAddressL;
    Text customer_emailAddressW;
    ISimpleWMClient customer_emailAddress;
    Composite infoComposite_set3W;
    Label infoComposite_set3_centered;
    Label customer_birthDateL;
    DatePicker customer_birthDateW;
    ISimpleWMClient customer_birthDate;
    Composite infoComposite_set4W;
    Label infoComposite_set4_centered;
    Label customer_telefonNumberL;
    Text customer_telefonNumberW;
    ISimpleWMClient customer_telefonNumber;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the Page1Gen.
     * @param notebook the Notebook this page belongs to.
     */
    public Page1Gen(Notebook notebook) {
        super(notebook,false);
        createModels();
    }

    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.dsl.reference.xma.customeredit.client.CustomerEdit",getGenPageLocale());
        }
        return genPageMessages;
    }

    /*
     * returns the scaler used for this page
    */
    final protected Scaler getScaler() {
        if (scaler == null) {
            scaler = Scaler.getInstance(getComposite());
        }
        return scaler;
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {
        IFmt formatter;
        CompoundValidator compound;
        customer_firstName = new SimpleWMClient((short) 0, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(25);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(25);
        compound.setFormatter(formatter);
        formatter = compound;
        customer_firstName.setFmt(formatter);
        customer_lastName = new SimpleWMClient((short) 1, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(50);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(50);
        compound.setFormatter(formatter);
        formatter = compound;
        customer_lastName.setFmt(formatter);
        customer_emailAddress = new SimpleWMClient((short) 2, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(40);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(40);
        compound.setFormatter(formatter);
        formatter = compound;
        customer_emailAddress.setFmt(formatter);
        customer_birthDate = new SimpleWMClient((short) 3, Types.T_DATE, this);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, getGenPageLocale());
        compound = new CompoundValidator(formatter);
        formatter = ADateFmt.getInstance(ADateFmt.MEDIUM, getGenPageLocale());
        compound.setFormatter(formatter);
        formatter = compound;
        customer_birthDate.setFmt(formatter);
        customer_telefonNumber = new SimpleWMClient((short) 4, Types.T_STRING, this);
        formatter = AStringFmt.getInstance(-1);
        compound = new CompoundValidator(formatter);
        formatter = AStringFmt.getInstance(-1);
        compound.setFormatter(formatter);
        formatter = compound;
        customer_telefonNumber.setFmt(formatter);

        widgetModels = new WModel[] { (WModel) customer_firstName, (WModel) customer_lastName, (WModel) customer_emailAddress, (WModel) customer_birthDate, (WModel) customer_telefonNumber };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        customer_firstName = null;
        customer_lastName = null;
        customer_emailAddress = null;
        customer_birthDate = null;
        customer_telefonNumber = null;
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return CustomerEdit.Page1Class;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public CustomerEdit getTypedComponent() {
        return (CustomerEdit) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = getScaler();

        Composite pageCompositePage1W = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        pageCompositePage1W.setLayout(layout);

        infoCompositeW = new Composite(pageCompositePage1W,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        infoCompositeW.setLayout(layout);
        infoCompositeW.setData("WIDGET_ID","infoCompositeW");

        infoComposite_set0W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set0W.setLayout(layout);
        infoComposite_set0W.setData("WIDGET_ID","infoComposite_set0W");

        infoComposite_set0_centered = new Label(infoComposite_set0W,SWT.LEFT);
        infoComposite_set0_centered.setVisible(false);
        infoComposite_set0_centered.setData("WIDGET_ID","infoComposite_set0_centered");

        customer_firstNameL = new Label(infoComposite_set0W,SWT.LEFT|SWT.WRAP);
        customer_firstNameL.setText(getGenPageMessages().getString("Page1.customer_firstNameL"));
        customer_firstNameL.setData("WIDGET_ID","customer_firstNameL");

        customer_firstNameW = new Text(infoComposite_set0W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer_firstNameW.setToolTipText(getGenPageMessages().getString("Page1.customer_firstNameWTip"));
        customer_firstNameW.setData("WIDGET_ID","customer_firstNameW");
        customer_firstNameW.addFocusListener(adapter);
        customer_firstNameW.addModifyListener(adapter);
        customer_firstNameW.addVerifyListener(adapter);

        infoComposite_set1W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set1W.setLayout(layout);
        infoComposite_set1W.setData("WIDGET_ID","infoComposite_set1W");

        infoComposite_set1_centered = new Label(infoComposite_set1W,SWT.LEFT);
        infoComposite_set1_centered.setVisible(false);
        infoComposite_set1_centered.setData("WIDGET_ID","infoComposite_set1_centered");

        customer_lastNameL = new Label(infoComposite_set1W,SWT.LEFT|SWT.WRAP);
        customer_lastNameL.setText(getGenPageMessages().getString("Page1.customer_lastNameL"));
        customer_lastNameL.setData("WIDGET_ID","customer_lastNameL");

        customer_lastNameW = new Text(infoComposite_set1W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer_lastNameW.setToolTipText(getGenPageMessages().getString("Page1.customer_lastNameWTip"));
        customer_lastNameW.setData("WIDGET_ID","customer_lastNameW");
        customer_lastNameW.addFocusListener(adapter);
        customer_lastNameW.addModifyListener(adapter);
        customer_lastNameW.addVerifyListener(adapter);

        infoComposite_set2W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set2W.setLayout(layout);
        infoComposite_set2W.setData("WIDGET_ID","infoComposite_set2W");

        infoComposite_set2_centered = new Label(infoComposite_set2W,SWT.LEFT);
        infoComposite_set2_centered.setVisible(false);
        infoComposite_set2_centered.setData("WIDGET_ID","infoComposite_set2_centered");

        customer_emailAddressL = new Label(infoComposite_set2W,SWT.LEFT|SWT.WRAP);
        customer_emailAddressL.setText(getGenPageMessages().getString("Page1.customer_emailAddressL"));
        customer_emailAddressL.setData("WIDGET_ID","customer_emailAddressL");

        customer_emailAddressW = new Text(infoComposite_set2W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer_emailAddressW.setToolTipText(getGenPageMessages().getString("Page1.customer_emailAddressWTip"));
        customer_emailAddressW.setData("WIDGET_ID","customer_emailAddressW");
        customer_emailAddressW.addFocusListener(adapter);
        customer_emailAddressW.addModifyListener(adapter);
        customer_emailAddressW.addVerifyListener(adapter);

        infoComposite_set3W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set3W.setLayout(layout);
        infoComposite_set3W.setData("WIDGET_ID","infoComposite_set3W");

        infoComposite_set3_centered = new Label(infoComposite_set3W,SWT.LEFT);
        infoComposite_set3_centered.setVisible(false);
        infoComposite_set3_centered.setData("WIDGET_ID","infoComposite_set3_centered");

        customer_birthDateL = new Label(infoComposite_set3W,SWT.LEFT|SWT.WRAP);
        customer_birthDateL.setText(getGenPageMessages().getString("Page1.customer_birthDateL"));
        customer_birthDateL.setData("WIDGET_ID","customer_birthDateL");

        customer_birthDateW = new DatePicker(infoComposite_set3W,SWT.SINGLE|SWT.BORDER|SWT.LEFT,DatePicker.RED_WEEKEND);
        customer_birthDateW.setDatePickerLocale(getGenPageLocale());
        customer_birthDateW.setToolTipText(getGenPageMessages().getString("Page1.customer_birthDateWTip"));
        customer_birthDateW.setData("WIDGET_ID","customer_birthDateW");
        customer_birthDateW.getDateTextField().addFocusListener(adapter);
        customer_birthDateW.getDateTextField().addModifyListener(adapter);
        customer_birthDateW.getDateTextField().addVerifyListener(adapter);

        infoComposite_set4W = new Composite(infoCompositeW,SWT.NONE);
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(0);
        layout.marginWidth = scaler.convertXToCurrent(0);
        infoComposite_set4W.setLayout(layout);
        infoComposite_set4W.setData("WIDGET_ID","infoComposite_set4W");

        infoComposite_set4_centered = new Label(infoComposite_set4W,SWT.LEFT);
        infoComposite_set4_centered.setVisible(false);
        infoComposite_set4_centered.setData("WIDGET_ID","infoComposite_set4_centered");

        customer_telefonNumberL = new Label(infoComposite_set4W,SWT.LEFT|SWT.WRAP);
        customer_telefonNumberL.setText(getGenPageMessages().getString("Page1.customer_telefonNumberL"));
        customer_telefonNumberL.setData("WIDGET_ID","customer_telefonNumberL");

        customer_telefonNumberW = new Text(infoComposite_set4W,SWT.SINGLE|SWT.BORDER|SWT.LEFT);
        customer_telefonNumberW.setToolTipText(getGenPageMessages().getString("Page1.customer_telefonNumberWTip"));
        customer_telefonNumberW.setData("WIDGET_ID","customer_telefonNumberW");
        customer_telefonNumberW.addFocusListener(adapter);
        customer_telefonNumberW.addModifyListener(adapter);
        customer_telefonNumberW.addVerifyListener(adapter);

        widgets = new Control[] { infoCompositeW, infoComposite_set0W, infoComposite_set0_centered, customer_firstNameL, customer_firstNameW, infoComposite_set1W, infoComposite_set1_centered, customer_lastNameL, customer_lastNameW, infoComposite_set2W, infoComposite_set2_centered, customer_emailAddressL, customer_emailAddressW, infoComposite_set3W, infoComposite_set3_centered, customer_birthDateL, customer_birthDateW, infoComposite_set4W, infoComposite_set4_centered, customer_telefonNumberL, customer_telefonNumberW };

        createWidgetsLayout();
        createWidgetsTabOrder();

    }

    /**
     * Create the layout of all SWT-Widgets of the page.
     * (Attachments, Distances, Sizes)
     */
    public void createWidgetsLayout() {
        FormData data;
        final Scaler scaler = getScaler();
        Control lastControl;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(10));
        infoCompositeW.setLayoutData(data);

        lastControl=null;
        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        infoComposite_set0W.setLayoutData(data);
        lastControl=infoComposite_set0W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        infoComposite_set1W.setLayoutData(data);
        lastControl=infoComposite_set1W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        infoComposite_set2W.setLayoutData(data);
        lastControl=infoComposite_set2W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        infoComposite_set3W.setLayoutData(data);
        lastControl=infoComposite_set3W;

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        if(lastControl!=null) {
            data.top = new FormAttachment(lastControl,scaler.convertYToCurrent(3),SWT.BOTTOM);
        } else {
            data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        }
        infoComposite_set4W.setLayoutData(data);
        lastControl=infoComposite_set4W;

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set0_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(infoComposite_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_firstNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(175);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(infoComposite_set0_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_firstNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set1_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(infoComposite_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_lastNameL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(350);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(infoComposite_set1_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_lastNameW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set2_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(infoComposite_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_emailAddressL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(280);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(infoComposite_set2_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_emailAddressW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set3_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(infoComposite_set3_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_birthDateL.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(90);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(infoComposite_set3_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_birthDateW.setLayoutData(data);

        data = new FormData();
        data.width = scaler.convertXToCurrent(1);
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        infoComposite_set4_centered.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(0,100,scaler.convertXToCurrent(130));
        data.top = new FormAttachment(infoComposite_set4_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_telefonNumberL.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(133));
        data.top = new FormAttachment(infoComposite_set4_centered,scaler.convertYToCurrent(0),SWT.CENTER);
        customer_telefonNumberW.setLayoutData(data);

    }

    /**
     * Create the tab order of all SWT-Widgets of the page.
     * (sets the focus and defines the tab order)
     */
    protected void createWidgetsTabOrder() {
        Control[] tabOrder;
        final Composite pageCompositePage1W = getComposite();
        tabOrder = new Control[1];
        tabOrder[0] = infoCompositeW;
        pageCompositePage1W.setTabList(tabOrder);
        tabOrder = new Control[5];
        tabOrder[0] = infoComposite_set0W;
        tabOrder[1] = infoComposite_set1W;
        tabOrder[2] = infoComposite_set2W;
        tabOrder[3] = infoComposite_set3W;
        tabOrder[4] = infoComposite_set4W;
        infoCompositeW.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer_firstNameW;
        infoComposite_set0W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer_lastNameW;
        infoComposite_set1W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer_emailAddressW;
        infoComposite_set2W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer_birthDateW;
        infoComposite_set3W.setTabList(tabOrder);
        tabOrder = new Control[1];
        tabOrder[0] = customer_telefonNumberW;
        infoComposite_set4W.setTabList(tabOrder);
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        infoCompositeW = null;
        infoComposite_set0W = null;
        infoComposite_set0_centered = null;
        customer_firstNameL = null;
        customer_firstNameW = null;
        infoComposite_set1W = null;
        infoComposite_set1_centered = null;
        customer_lastNameL = null;
        customer_lastNameW = null;
        infoComposite_set2W = null;
        infoComposite_set2_centered = null;
        customer_emailAddressL = null;
        customer_emailAddressW = null;
        infoComposite_set3W = null;
        infoComposite_set3_centered = null;
        customer_birthDateL = null;
        customer_birthDateW = null;
        infoComposite_set4W = null;
        infoComposite_set4_centered = null;
        customer_telefonNumberL = null;
        customer_telefonNumberW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
        customer_firstNameW.setData(customer_firstName.getUIDelegate());
        customer_firstName.getUIDelegate().attachUI(customer_firstNameW,customer_firstNameL);
        customer_lastNameW.setData(customer_lastName.getUIDelegate());
        customer_lastName.getUIDelegate().attachUI(customer_lastNameW,customer_lastNameL);
        customer_emailAddressW.setData(customer_emailAddress.getUIDelegate());
        customer_emailAddress.getUIDelegate().attachUI(customer_emailAddressW,customer_emailAddressL);
        customer_birthDateW.getDateTextField().setData(customer_birthDate.getUIDelegate());
        customer_birthDate.getUIDelegate().attachUI(customer_birthDateW.getDateTextField(),customer_birthDateL);
        customer_telefonNumberW.setData(customer_telefonNumber.getUIDelegate());
        customer_telefonNumber.getUIDelegate().attachUI(customer_telefonNumberW,customer_telefonNumberL);
    }

    /**
     * Enables or disables Widgets according to the current state of the page.
     * This method is called every time the content of any WizardModel of the
     * Page may have been changed. <br>
     * This method is called immediately after {@link #determineState()}.
     */
    public void stateChanged() {
        super.stateChanged();
        customer_firstName.setMandatory(true);
        customer_lastName.setMandatory(true);
        customer_emailAddressL.setEnabled(!(false));
        customer_emailAddress.setMandatory(true);
        customer_emailAddress.setEnabled(!(false));
        customer_birthDate.setMandatory(true);
        customer_telefonNumber.setMandatory(false);
    }

    /**
     * This method will be called every time the Page1 becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

    /**
     * Creates the coresponding TabItem
     */
    protected TabItem createTabItem(TabFolder tabfolder1W,int index) {
        TabItem page1W = new TabItem (tabfolder1W, SWT.NULL, index);
        page1W.setText(getGenPageMessages().getString("Page1"));
        page1W.setControl(getComposite());
        page1W.setData(this);

        return page1W;
    }
}
