package org.openxma.dsl.reference.xma.tablewithmenucomponent.server;

import at.spardat.xma.page.*;
import at.spardat.xma.component.*;
import at.spardat.xma.mdl.*;
import at.spardat.xma.mdl.table.*;
import java.util.*;

/**
 * This class implements the generic server part of MainPage.
 * It implements the models of the page.
 *
 */
public abstract class MainPageGen extends PageServer {
    ITableWM paramTable;
    static final int PARAMTABLE_FIRSTNAME = 0;
    WModel[] widgetModels;

    java.util.Collection customer;

    /**
     * Constructs the MainPageGen.
     * This constructor is called by the runtime. Do not remove!
     *
     * @param component the component this page belongs to
     */
    public MainPageGen(ComponentServer component) {
        super(component, false);
        createModels();
    }

    /**
     * Create and initialize the WidgetModels of the page.
     */
    public void createModels() {
        paramTable = new TableWM((short) 0,this,1,TableWM.S_NULL|TableWM.S_ONE_WAY);

        widgetModels = new WModel[] { (WModel) paramTable };
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return TableWithMenuComponent.MainPageClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public TableWithMenuComponent getTypedComponent() {
        return (TableWithMenuComponent) getComponent();
    }

    /**
     * returns the customer
     */
    public java.util.Collection getCustomer() {
        return customer;
    }

    /**
     * sets the customer
     */
    public void setCustomer(java.util.Collection customer) {
        this.customer = customer;
    }

    /**
     * Copies values of all attached widget models to attributes of the BusinessData instance variables.
     * Copies them for this page and all contained NotebookPages and statically embedded Pages
     * (embedded via XMAContainer in guidesigner)
     */
    public void modelToInstanceData() {
    }

    /**
     * Copies attribute values of the BusinessData instance variables into their attached widget models.
     * This includes simple widget models and tables.
     * Copies them for this page and all contained NotebookPages and statically embedded Pages
     * (embedded via XMAContainer in guidesigner)
     */
    public void instanceDataToModel() {
        paramTableFill();
    }

    /**
     * This is a support method to create the table cells of one row from one or more BusinessDatas.
     * You may overwrite this method if you need a custom mapping from BusinessData attributes
     * to table columns that you were unable to specify in the UI designer.
     *
     * @return the returned Object[] is needed in the constructor of a <tt>TableRow</tt>.
     */
    public Object[] paramTableCreateCells(org.openxma.dsl.reference.dto.CustomerView customer) {
        Object []  cells = new Object[1];
        cells[0] = customer.getFirstName();
        return cells;
    }

    /**
     * This method creates a TableRow object and adds it to the end of the table.
     * The key of the row is drawn from the key attribute specified in the UI designer.
     * The image id is resolved by calling paramTableGetImageId. The cells of the table
     * are taken from a call to paramTableCreateCells.
     */
    public TableRow paramTableAddRow (org.openxma.dsl.reference.dto.CustomerView customer) {
        return new TableRow ((TableWM)paramTable, customer.getOid().toString(), paramTableCreateCells (customer), paramTableGetImageFor (customer));
    }

    /**
     * This method is called from <tt>paramTableAddRow</tt> to figure out an image
     * id for a particular row. If you do not overwrite this method, the table row
     * does not have an image id. 
     */
    public int paramTableGetImageFor (org.openxma.dsl.reference.dto.CustomerView customer) {
        return 0;
    }

    /**
     * This method iterates over the collection and calls <tt>paramTableAddRow</tt> for
     * each element.
     */
    public void paramTableFill () {
        paramTable.clear();
        for (Iterator iter = customer.iterator(); iter.hasNext();) {
            paramTableAddRow ((org.openxma.dsl.reference.dto.CustomerView) iter.next());
        }
    }

    /**
     * Sets the given subpage. The method automatically chooses the
     * correct member variable to set.
     * @param child the subpage to set.
     */
    public void setChild(PageServer child) {
       // no subpages - nothing to do
    }

    /**
     * Removes the given subpage. The method automatically chooses the
     * correct member variable to clear.
     * @param child the subpage to set.
     */
    public void removeChild(PageServer child) {
       // no subpages - nothing to do
    }

}
